/* 
 *      XSitecopy, for managing remote web sites with a GNOME interface.
 *      Copyright (C) 1999, Lee Mallabone <lee0@callnetuk.com
 *                                                                        
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *     
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *     
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 */

/* FIXME! This needs to be made a little more generic to accomodate all the
 * possible calling contexts; ie. normal, from a druid, from slim mode.
 */

#include "resynch.h"

static int should_abort_resync = 0;

GtkWidget *fetch_list_window, *fetch_list_bar, *fetch_message;
GtkWidget *fetch_clist;
GtkWidget *close_fetch_button, *begin_fetch_button;

extern GtkWidget *connection_label;
float activity = 0.0;
extern struct site *selected_site;

int fetch_site_list_please(GtkWidget * update_button, gpointer data)
{

    GtkWidget *dialog_vbox7;
    GtkWidget *vbox10;
    GtkWidget *hbox4;
    GtkWidget *label17;
    GtkWidget *scrolledwindow1;
    GtkWidget *label18;
    GtkWidget *dialog_action_area7;

    if (!selected_site) {
	gnome_error_dialog("You must select a site before trying to fetch file information");
	return 0;
    }
/** Generated by Glade **/
    fetch_list_window = gnome_dialog_new(NULL, NULL);
    gtk_object_set_data(GTK_OBJECT(fetch_list_window), "fetch_list_window", fetch_list_window);
    gtk_window_set_policy(GTK_WINDOW(fetch_list_window), FALSE, FALSE, FALSE);

    dialog_vbox7 = GNOME_DIALOG(fetch_list_window)->vbox;
    gtk_object_set_data(GTK_OBJECT(fetch_list_window), "dialog_vbox7", dialog_vbox7);
    gtk_widget_show(dialog_vbox7);

    vbox10 = gtk_vbox_new(FALSE, 5);
    gtk_widget_ref(vbox10);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "vbox10", vbox10,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox10);
    gtk_box_pack_start(GTK_BOX(dialog_vbox7), vbox10, TRUE, TRUE, 0);

    hbox4 = gtk_hbox_new(FALSE, 0);
    gtk_widget_ref(hbox4);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "hbox4", hbox4,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hbox4);
    gtk_box_pack_start(GTK_BOX(vbox10), hbox4, FALSE, FALSE, 0);

    label17 = gtk_label_new("Status: ");
    gtk_widget_ref(label17);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "label17", label17,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label17);
    gtk_box_pack_start(GTK_BOX(hbox4), label17, FALSE, FALSE, 0);

    fetch_message = gtk_label_new("Awaiting user input");
    gtk_widget_ref(fetch_message);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "fetch_message", fetch_message,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(fetch_message);
    gtk_box_pack_start(GTK_BOX(hbox4), fetch_message, TRUE, TRUE, 0);
    gtk_label_set_justify(GTK_LABEL(fetch_message), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment(GTK_MISC(fetch_message), 0, 0.5);

    fetch_list_bar = gtk_progress_bar_new();
    gtk_widget_ref(fetch_list_bar);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "fetch_list_bar", fetch_list_bar,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(fetch_list_bar);
    gtk_box_pack_start(GTK_BOX(vbox10), fetch_list_bar, FALSE, FALSE, 0);
    gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(fetch_list_bar), GTK_PROGRESS_DISCRETE);
    gtk_progress_set_activity_mode(GTK_PROGRESS(fetch_list_bar), TRUE);

    scrolledwindow1 = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_ref(scrolledwindow1);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "scrolledwindow1", scrolledwindow1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(scrolledwindow1);
    gtk_box_pack_start(GTK_BOX(vbox10), scrolledwindow1, TRUE, TRUE, 0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    fetch_clist = gtk_clist_new(1);
    gtk_widget_ref(fetch_clist);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "fetch_clist", fetch_clist,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(fetch_clist);
    gtk_container_add(GTK_CONTAINER(scrolledwindow1), fetch_clist);
    gtk_widget_set_usize(fetch_clist, -2, 140);
    gtk_clist_set_column_width(GTK_CLIST(fetch_clist), 0, 80);
    gtk_clist_set_selection_mode(GTK_CLIST(fetch_clist), GTK_SELECTION_BROWSE);
    gtk_clist_column_titles_show(GTK_CLIST(fetch_clist));

    label18 = gtk_label_new("Found information about these files");
    gtk_widget_ref(label18);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "label18", label18,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label18);
    gtk_clist_set_column_widget(GTK_CLIST(fetch_clist), 0, label18);

    dialog_action_area7 = GNOME_DIALOG(fetch_list_window)->action_area;
    gtk_object_set_data(GTK_OBJECT(fetch_list_window), "dialog_action_area7", dialog_action_area7);
    gtk_widget_show(dialog_action_area7);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area7), GTK_BUTTONBOX_SPREAD);
    gtk_button_box_set_spacing(GTK_BUTTON_BOX(dialog_action_area7), 8);
    gtk_button_box_set_child_ipadding(GTK_BUTTON_BOX(dialog_action_area7), 0, 0);

    gnome_dialog_append_button_with_pixmap(GNOME_DIALOG(fetch_list_window),
			 "Fetch file states", GNOME_STOCK_PIXMAP_SEARCH);
    begin_fetch_button = g_list_last(GNOME_DIALOG(fetch_list_window)->buttons)->data;
    gtk_widget_ref(begin_fetch_button);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "begin_fetch_button", begin_fetch_button,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(begin_fetch_button);
    GTK_WIDGET_SET_FLAGS(begin_fetch_button, GTK_CAN_DEFAULT);

    gnome_dialog_append_button(GNOME_DIALOG(fetch_list_window), GNOME_STOCK_BUTTON_CLOSE);
    close_fetch_button = g_list_last(GNOME_DIALOG(fetch_list_window)->buttons)->data;
    gtk_widget_ref(close_fetch_button);
    gtk_object_set_data_full(GTK_OBJECT(fetch_list_window), "close_fetch_button", close_fetch_button,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(close_fetch_button);
    GTK_WIDGET_SET_FLAGS(close_fetch_button, GTK_CAN_DEFAULT);

    gtk_signal_connect(GTK_OBJECT(begin_fetch_button), "clicked",
		       GTK_SIGNAL_FUNC(start_fetch_list),
		       NULL);
    gtk_signal_connect(GTK_OBJECT(close_fetch_button), "clicked",
		       GTK_SIGNAL_FUNC(close_fetch_window),
		       NULL);

/** End Glade generated code **/

    connection_label = fetch_message;
    gtk_window_set_modal(GTK_WINDOW(fetch_list_window), TRUE);
    gtk_widget_show(fetch_list_window);
    return 1;
}

void close_fetch_window(void)
{
    gtk_window_set_modal(GTK_WINDOW(fetch_list_window), FALSE);
    gtk_widget_destroy(fetch_list_window);
    connection_label = NULL;
}

int start_fetch_list(void)
{
    pthread_t fetch_thread_id = 0;

    if (pthread_create(&fetch_thread_id, NULL, actual_fetch_list,
		       NULL) != 0) {
	fe_status("There was a problem creating the thread to fetch site info.\n");
	return 0;
    }
    if (fetch_thread_id != 0)
	pthread_join(fetch_thread_id, NULL);
    gtk_window_set_modal(GTK_WINDOW(fetch_list_window), FALSE);
    return 1;
}

void *actual_fetch_list(void *nothing)
{
    int ret;

    pthread_detach(pthread_self());

    gtk_widget_set_sensitive(begin_fetch_button, FALSE);
    gtk_widget_set_sensitive(close_fetch_button, FALSE);

    ret = verifysite_gnome(selected_site);
   DEBUG (DEBUG_GNOME, "Verified correctness, beginning fetch...\n");
    if (ret)
	return NULL;
    ret = site_fetch(selected_site);
   DEBUG (DEBUG_GNOME, "Fetch terminated, checking return code...\n");
    switch (ret) {
    case SITE_OK:
	gtk_label_set(GTK_LABEL(fetch_message), "Remote site's file list successfully fetched.");
	site_write_stored_state(selected_site);
       DEBUG (DEBUG_GNOME, "Site fetch was successful.\n");
	break;
    case SITE_UNIMPL:
	gtk_label_set(GTK_LABEL(fetch_message), "Fetch mode not implemented for this protocol.");
       DEBUG (DEBUG_GNOME, "NOt implemented!\n");
	break;
    case SITE_AUTH:
	gtk_label_set(GTK_LABEL(fetch_message), "Could not authenticate you with the remote server.");
       DEBUG (DEBUG_GNOME, "Could not authenticate\n");
	break;
    case SITE_LOOKUP:
	gtk_label_set(GTK_LABEL(fetch_message), "Host name lookup failed.");
       DEBUG (DEBUG_GNOME, "lookup failed\n");
	break;
    case SITE_CONNECT:
	gtk_label_set(GTK_LABEL(fetch_message), "Could not connect to remote site.");
       DEBUG (DEBUG_GNOME, "no connection.\n");
	break;
    case SITE_FAILED:
	gtk_label_set(GTK_LABEL(fetch_message), "The fetch failed. No reason given.");
       DEBUG (DEBUG_GNOME, "Fetch failed.\n");
	break;
    default:
	gtk_label_set(GTK_LABEL(fetch_message), "This should never appear. Please contact the maintainer.");
       DEBUG (DEBUG_GNOME, "default.\n");
    }
    gtk_widget_set_sensitive(close_fetch_button, TRUE);
    gtk_widget_set_sensitive(begin_fetch_button, TRUE);
    return NULL;
}

/* FIXME! Change this to add stuff to the clist. */
void fe_fetch_found(const struct site_file *file)
{
    gchar *info;
    gchar *col[1];

    info = g_strdup_printf("Found information for %s.", file_name(file));
    gtk_label_set(GTK_LABEL(fetch_message), info);
    g_free(info);

    /* Should check this really. Is it possible that this will cause
     * SEGV if file no longer exists locally?
     */
    col[0] = file_name(file);
    gtk_clist_append(GTK_CLIST(fetch_clist), col);

    gtk_progress_bar_update(GTK_PROGRESS_BAR(fetch_list_bar), (activity == 1.0) ? 0.0 : (activity + 0.2));
    while (gtk_events_pending() > 0)
	gtk_main_iteration();
    return;
}

int fe_abort_synch(struct site *site)
{
    return should_abort_resync;
}
